
; Public Domain

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

	cpu 8086

	addsection RELOCATEDDATA, nobits vstart=8000h
relocateddata:

	addsection HEADER, start=0

		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
	iend


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "PRINTF"
	iend


command:
	jmp strict short .entry
.chain:
	extcall cmd3_not_ext		; must NOT be extcallcall
	times 10 - ($ - command) nop
.entry:
	push si
	cmp al, '-'
	jne @F
	extcallcall skipcomma
@@:
	dec si

	mov dx, msg.printf
internaldatarelocation
	extcallcall isstring?
	je .ours
	pop si
	dec si
	lodsb
	jmp .chain

.ours:
	pop ax
	extcallcall skipcomma
	dec si
	mov dx, relocateddata
linkdatarelocation msg.uninstall
	extcallcall isstring?
	je uninstall
	lodsb
	call run
	extcallcall cmd3

uninstall:
	lodsb
	extcallcall chkeol

	mov es, word [relocateddata]
linkdatarelocation extdssel
	extcallcall ispm
	jz @F
	mov es, word [relocateddata]
linkdatarelocation extseg
@@:
	push es
	pop ds
	xor bx, bx		; = 0 (no prior, modify ext_command_handler)
	mov di, command		; di -> us
internalcoderelocation
	mov si, word [ss:relocateddata]
linkdatarelocation ext_command_handler
				; si -> first
	test si, si		; none installed ?
	jz .error		; error -->

.loop:
	cmp di, si		; found ?
	je .bx			; yes, use bx -->
	mov bx, si		; bx -> prior handler
	lodsw			; skip entrypoint jmp strict short
	lodsb			; get first byte of chainer
	cmp al, 0E9h		; expecting jmp near ?
	jne .error		; no, error -->
	lodsw			; get rel16 displacement
	add si, ax		; -> next handler
	jmp .loop

.bx:
	test bx, bx		; any prior ?
	jnz .bxnz		; yes -->
	scasw			; skip entrypoint jmp strict short
	cmp byte [di], 0E8h	; is it a call to cmd3_not_ext ?
	jne @F			; no -->
				; yes, reset ext_command_handler to zero
.setbx:
	mov word [ss:relocateddata], bx
linkdatarelocation ext_command_handler
	jmp .done

@@:
	cmp byte [di], 0E9h	; validate
	jne .error		; failure -->
	inc di			; -> rel16 displacement
	mov bx, word [di]	; get displacement
	scasw			; -> after jmp near
	add bx, di		; -> next handler
	jmp .setbx		; set ext_command_handler to next

.bxnz:
	mov si, bx		; -> prior handler with us as downlink
	xchg di, si		; si -> ours, di -> prior
	cmpsw			; skip entrypoint jmp strict short
	movsb			; copy 0E8h/0E9h
	lodsw			; ax = near rel16 displacement
	add ax, si		; add in our base (= absolute offset)
	sub ax, di
	dec ax
	dec ax			; subtract new base (= relative displacement)
	stosw			; store new rel16 displacement
	movsw			; jmp strict short
	movsw			; linkcall target
	movsb			; trailer
.done:
	clropt [code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as free
	mov dx, msg.uninstall_done
internaldatarelocation
@@:
	push ss
	pop ds
	extcallcall putsz
	extcallcall cmd3	; return

.error:
	mov dx, msg.uninstall_error
internaldatarelocation
	jmp @B


run:
	lframe none
	lequ 16, line_out_reserved
	lequ 16, buffersize
	lvar ?buffersize, buffer
	lvar word, type
	lvar word, width
	lvar word, pad
	lvar word, preprefixlength
	lvar word, postprefixlength
	lvar word, prefixes
	lenter
	push ss
	pop es

	extcallcall skipwh0
	cmp al, '"'
	je @F
	cmp al, "'"
	je @F
	mov dx, msg.no_quote
internaldatarelocation
.putsz_end:
	extcallcall putsz
	jmp end

@@:
	lvar word, quote
	 push ax
	mov ah, al
	lvar word, startstring
	 push si			; -> text

.unquote_loop:
	lodsb
	cmp al, '\'
	je .unquote_backslash
	cmp al, ah
	je .unquote_check
	extcallcall iseol?.notsemicolon
	jne .unquote_loop

.unexpected_eol:
	mov dx, msg.no_unquote
internaldatarelocation
	jmp .putsz_end

.unquote_backslash:
	lodsb
	extcallcall iseol?.notsemicolon
	je .unexpected_eol
	jmp .unquote_loop

.unquote_check:
	lodsb				; si -> after next text
	cmp al, ah
	je .unquote_loop
	dec si				; -> next text
	dec si				; -> closing quote mark
	lvar word, endstring
	 push si			; -> closing quote mark, behind text
	mov byte [si], 0
	lvar word, nextparam
	inc si
	 push si			; -> after closing quote mark

	mov si, [bp + ?startstring]
	mov di, relocateddata
linkdatarelocation line_out

.loop:
	cmp di, strict word relocateddata - ?line_out_reserved
linkdatarelocation line_out_end
	jb @F
	call .dump
@@:
	lodsb
.loop_al:
	cmp al, 0
	je .end
	cmp al, '\'
	je .backslash
	cmp al, '%'
	je .percent
	cmp al, byte [bp + ?quote]
	jne .store
.quote:
	inc si
.store:
	stosb
	jmp .loop


.backslash:
	lodsb
	cmp al, 0
	je .end
	cmp al, 'A'
	jb .store
	cmp al, 'Z'
	jbe @F
	cmp al, 'a'
	jb .store
	cmp al, 'z'
	ja .store
	sub al, 'a' - 'A' - 26
@@:
	sub al, 'A'
	mov bx, backslashletters
internaldatarelocation
	xlatb
	cmp al, 0
	jnz .store
	lodsb
	extcallcall getnyb
	jc .loop_al
	xchg bx, ax
	lodsb
	extcallcall getnyb
	jc .onedigit
	add bl, bl
	add bl, bl
	add bl, bl
	add bl, bl
	add bl, al
	db __TEST_IMM8		; (skip dec)
.onedigit:
	dec si
	xchg bx, ax
	jmp .store

.percent:
	xor bx, bx
	mov word [bp + ?preprefixlength], bx
	mov word [bp + ?postprefixlength], bx
	mov byte [bp + ?pad], 32
@@:
	lodsb
	cmp al, 0
	je .end
	cmp al, '%'
	je .store

	cmp al, '0'
	jb @F
	jne .notzero
	test bx, bx
	jnz .notzero
	mov byte [bp + ?pad], al
	jmp @B

.notzero:
	cmp al, '9'
	ja @F
	sub al, '0'
	add bx, bx		; times 2
	mov dx, bx
	add bx, bx		; times 4
	add bx, bx		; times 8
	add bx, dx		; times 10
	mov ah, 0
	add bx, ax
	jmp @B

@@:
	mov ah, al
	and ah, 20h
	mov word [bp + ?type], ax
	mov word [bp + ?width], bx
	cmp al, 'X'
	je .hex
	cmp al, 'x'
	je .hex
	cmp al, 'u'
	je .unsigned
	cmp al, 'U'
	je .unsigned
	cmp al, 'd'
	je .signed
	cmp al, 'D'
	je .signed
	cmp al, 'i'
	je .signed
	cmp al, 'I'
	je .signed
	cmp al, 'c'
	je .codepoint
	cmp al, 'C'
	je .codepoint
	mov dx, msg.unknown
internaldatarelocation
	jmp .putsz_end


.codepoint:
	push si
	mov si, word [bp + ?nextparam]
	extcallcall skipwhite
	extcallcall getbyte
	dec si
	mov word [bp + ?nextparam], si
	mov cx, word [bp + ?width]
	sub cx, 1
	jbe @F
	mov al, 32
	call .pad
@@:
	xchg ax, dx
	stosb
	pop si
	jmp .loop


.signed:
	push si
	push di
	mov si, word [bp + ?nextparam]
	extcallcall skipwhite
	extcallcall getexpression
	dec si
	mov word [bp + ?nextparam], si
	lea di, [bp + ?buffer + ?buffersize - 1]
	test bh, bh
	jns .unsigned_common
	cmp byte [bp + ?pad], '0'
	jne @F
	mov word [bp + ?preprefixlength], 1
	mov byte [bp + ?prefixes], '-'
	jmp @FF

@@:
	mov word [bp + ?postprefixlength], 1
	mov byte [bp + ?prefixes + 1], '-'
@@:
	neg bx
	neg dx
	sbb bx, byte 0		; neg bx:dx
	jmp @F


.unsigned:
	push si
	push di
	mov si, word [bp + ?nextparam]
	extcallcall skipwhite
	extcallcall getexpression
	dec si
	mov word [bp + ?nextparam], si
	lea di, [bp + ?buffer + ?buffersize - 1]
.unsigned_common:
@@:
	std
@@:
	xchg ax, bx
	push dx
	xor dx, dx
	mov cx, 10
	div cx			; dx = remainder, ax = quotient high
	xchg bx, ax		; bx = quotient high
	pop ax			; dx:ax = remainder:low word
	div cx			; dx = remainder, bx:ax = quotient
	xchg ax, dx		; bx:dx = quotient
	add al, '0'
	stosb
	mov cx, dx
	or cx, bx
	jnz @B
	jmp .common_number


.hex:
	push si
	push di
	mov si, word [bp + ?nextparam]
	extcallcall skipwhite
	extcallcall getexpression
	dec si
	mov word [bp + ?nextparam], si
	lea di, [bp + ?buffer + ?buffersize - 1]
	std
@@:
	mov al, dl
	extcallcall hexnyb
	mov al, byte [bp + ?type + 1]
	or byte [di + 1], al
	mov cx, 4
@@:
	shr bx, 1
	rcr dx, 1
	loop @B
	test bx, bx
	jnz @BB
	test dx, dx
	jnz @BB
.common_number:
	cld
	inc di
	lea bx, [bp + ?buffer + ?buffersize]
	sub bx, di
	mov si, di
	pop di
	add bx, word [bp + ?preprefixlength]
	add bx, word [bp + ?postprefixlength]
	mov cx, word [bp + ?preprefixlength]
	mov al, byte [bp + ?prefixes]
	rep stosb
	mov cx, word [bp + ?width]
	mov al, byte [bp + ?pad]
	sub cx, bx
	jbe @F
	call .pad
@@:
	mov cx, word [bp + ?postprefixlength]
	mov al, byte [bp + ?prefixes + 1]
	rep stosb
	mov cx, bx
	sub cx, word [bp + ?preprefixlength]
	sub cx, word [bp + ?postprefixlength]
	rep movsb
	pop si
	jmp .loop

.dump:
	extcallcall putsline
	mov di, relocateddata
linkdatarelocation line_out
	retn


.pad:
	cmp cx, ?line_out_reserved - 1 - 10
	jbe @FF
@@:
	push ax
	push bx
	push cx
	call .dump
	pop cx
	pop bx
	pop ax
	cmp cx, 256 - 1 - 10
	jbe @F
	sub cx, 128
	push cx
	mov cx, 128
	rep stosb
	pop cx
	jmp @B
@@:
	rep stosb
	retn


.end:
	call .dump

end:
	lleave
	retn


	eldcall_dump_callcall ELDCALL_CALLCALL_LIST

endinstalled equ ($ + CODEFIXUP + 15) & ~15


start:
	mov bx, es
	 push ss
	 pop es
	call skipcomma
	dec si
	mov dx, relocateddata
linkdatarelocation msg.install
	call isstring?
	je install
	lodsb
	call run
	call uninstall_oneshot
	xor ax, ax
	retf


uninstall_oneshot:
	testopt [ss:relocateddata], 1
linkdatarelocation options7, -3
	jnz @F

	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used

	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extdata_used
@@:
	retn


install:
	lodsb
	extcall chkeol

	houdini
	mov es, bx		; => ext seg (writable)
	mov ax, endresident - endinstalled
	sub word [es:code + eldiEndCode], ax
internalcoderelocation		; adjust size
	sub word [relocateddata], ax
linkdatarelocation extseg_used	; adjust size
	mov bx, word [relocateddata]
linkdatarelocation ext_command_handler
				; -> prior
	mov di, command		; -> our handler
internalcoderelocation
	test bx, bx		; installing as first ?
	jz .only_first		; yes, simple --> (leave as extcall cmd3_not_ext)
	scasw			; skip entrypoint jmp strict short
	mov al, 0E9h		; = jmp near opcode
	stosb			; store
	xchg ax, bx		; ax -> next handler
	sub ax, di
	dec ax
	dec ax			; ax = ax - (di + 2)
	stosw			; store our downlink as rel16 displacement

.only_first:
	setopt [es:code + eldiFlags], eldifResident
internalcoderelocation -3	; mark block as resident
	mov word [relocateddata], command
linkdatarelocation ext_command_handler, -4
internalcoderelocation		; -> our entrypoint

	testopt [relocateddata], 4
linkdatarelocation options7, -3
	jnz @F
	mov dx, msg.installed
internaldatarelocation
	call putsz
@@:
	xor ax, ax
	retf


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%define DATAFIXUP - datastart + 0
datastart:

%define LETTERSLOOKUP ""
%assign LETTER 'A'
%rep 26
 %xdefine LETTERSLOOKUP LETTERSLOOKUP, LETTER
 %assign LETTER LETTER + 1
%endrep
%assign LETTER 'a'
%rep 26
 %xdefine LETTERSLOOKUP LETTERSLOOKUP, LETTER
 %assign LETTER LETTER + 1
%endrep

	%imacro backslashletter 2.nolist
%assign %%letter %1 - 'a'
%assign LETTERBEFORE %%letter
%assign LETTERAFTER 26 - 1 - %%letter
%assign LETTER %2
%define LETTERSLOOKUPNEW ""
	letterappend LETTERSLOOKUP
%xdefine LETTERSLOOKUP LETTERSLOOKUPNEW
	%endmacro

%imacro letterappend 53.nolist
%rotate 1
%rep LETTERBEFORE
 %xdefine LETTERSLOOKUPNEW LETTERSLOOKUPNEW, %1
 %rotate 1
%endrep
%xdefine LETTERSLOOKUPNEW LETTERSLOOKUPNEW, LETTER
%rotate 1
%rep LETTERAFTER
 %xdefine LETTERSLOOKUPNEW LETTERSLOOKUPNEW, %1
 %rotate 1
%endrep
%rep LETTERBEFORE
 %xdefine LETTERSLOOKUPNEW LETTERSLOOKUPNEW, %1
 %rotate 1
%endrep
%xdefine LETTERSLOOKUPNEW LETTERSLOOKUPNEW, LETTER
%rotate 1
%rep LETTERAFTER
 %xdefine LETTERSLOOKUPNEW LETTERSLOOKUPNEW, %1
 %rotate 1
%endrep
%endmacro

backslashletter 'b', 8
backslashletter 't', 9
backslashletter 'n', 10
backslashletter 'r', 13
backslashletter 's', 32
backslashletter 'f', 12
backslashletter 'x', 0

backslashletters:
	db LETTERSLOOKUP


msg:
.printf:		asciz "PRINTF"
.uninstall_done:	asciz "PRINTF uninstalled. (Don't forget to use reclaim.eld)",13,10
.uninstall_error:	asciz "PRINTF unable to uninstall!",13,10
.no_quote:		asciz "PRINTF error: No starting quote mark!",13,10
.no_unquote:		asciz "PRINTF error: No ending quote mark!",13,10
.unknown:		asciz "PRINTF error: Unknown percent specifier!",13,10


uinit_data: equ $

.installed:		asciz "PRINTF installed.",13,10

	align 16, db 0
init_data_end:
data_size equ $ - datastart

	absolute uinit_data

	alignb 16
uinit_data_end:
resident_data_end:

%if uinit_data_end >= init_data_end
 total_data_size equ $ - datastart
%else
 total_data_size equ init_data_end - datastart
%endif
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
